#include "DxLib.h"
#include "KeyBoard.h"

const double G = 0.5;

typedef struct
{
	int x;
	int y;
	double v;
}dot_t;

typedef struct
{
	dot_t dot[640];
	int late;
}wave_t;

void Wave_Init();
void Wave_Update();
void Wave_Draw();

wave_t wave[2];
wave_t *current_wave = &wave[0]; // ݎł̔g
wave_t *next_wave = &wave[1]; // ̎ł̔g

void Wave_Init()
{
		//x(P:frame)
	current_wave->late = 1;
	for (int i = 0; i < 640; i++)
	{
		current_wave->dot[i].x = i;
		current_wave->dot[i].y = 240;
		current_wave->dot[i].v = 0;
 	}
}

void Wave_Update()
{
		//SɌĉx
	if (current_wave->dot[0].y < 240) {
		next_wave->dot[0].v = current_wave->dot[0].v - G;
	} else if (current_wave->dot[0].y > 240) {
		next_wave->dot[0].v = current_wave->dot[0].v + G;
	} else {
		next_wave->dot[0].v = current_wave->dot[0].v;
	}

		//x̃Rs[
	for (int i = 0; i < 640; i++)
	{
		if (i + 1 < 640)
		{
				//O̓_̉x̓_̉xփRs[
			next_wave->dot[i + 1].v = current_wave->dot[i].v;
		}
			//Wɑ΂Ĉړ
		next_wave->dot[i].x = current_wave->dot[i].x;
		next_wave->dot[i].y = current_wave->dot[i].y - next_wave->dot[i].v;
	}
	
		//ZL[ŉx
	if (KeyBoard_Get(KEY_INPUT_Z) > 1) next_wave->dot[0].v = 2;

	// g̃f[^̃obt@ւ
	{
		wave_t *temp = current_wave;
		current_wave = next_wave;
		next_wave = temp;
	}
}

void Wave_Draw()
{
		//`
	for (int i = 0; i < 640; i++)
	{
		DrawPixel(current_wave->dot[i].x, current_wave->dot[i].y, GetColor(255, 255, 255));
	}
}

