#include "DxLib.h"

static int keyCount[256];

int KeyBoard_Update(void) {
	char key[256];
	if (GetHitKeyStateAll(key)!=0)return -1;
	for (int i = 0; i < 256; i++) {
		keyCount[i] = key[i] ? keyCount[i] + 1 : 0;
	}
	return 0;
}

int KeyBoard_Get(int kiikoodo) {
	if (kiikoodo < 0 || 256 <= kiikoodo) return 0;
	return keyCount[kiikoodo];
}
