#include "DxLib.h"
#include "KeyBoard.h"

void Wave_Init();
void Wave_Update();
void Wave_Draw();

int WINAPI WinMain(HINSTANCE,HINSTANCE,TCHAR*,int) {
	ChangeWindowMode(TRUE);
	DxLib_Init();
	SetDrawScreen(DX_SCREEN_BACK);
	Wave_Init();
	while(ClearDrawScreen()==0 && ProcessMessage()==0 && KeyBoard_Update()==0) {
		// ESCL[ŏI
		if (KeyBoard_Get(KEY_INPUT_ESCAPE) == 1) break;
		// QL[ŃZbg
		if (KeyBoard_Get(KEY_INPUT_Q) == 1) Wave_Init();

		Wave_Update();
		Wave_Draw();
		ScreenFlip();
	}
	DxLib_End();
	return 0;
}
