#include "DxLib.h"
#include "KeyBoard.h"

const double G = 0.5;

typedef struct
{
	int x;
	int y;
	double v;
}dot_t;

typedef struct
{
	dot_t dot[640];
	int late;
}wave_t;

void Wave_Init();
void Wave_Update();
void Wave_Draw();

wave_t wave;


void Wave_Init()
{
		//x(P:frame)
	wave.late = 1;
	for (int i = 0; i < 640; i++)
	{
		wave.dot[i].x = i;
		wave.dot[i].y = 240;
		wave.dot[i].v = 0;
 	}
}

void Wave_Update()
{
		//SɌĉx
	if (wave.dot[0].y < 240) wave.dot[0].v -= G;
	if (wave.dot[0].y > 240) wave.dot[0].v += G;
	
		//x̃Rs[
	for (int i = 0; i < 640; i++)
	{
			//O̓_̉x̓_̉xփRs[
		wave.dot[i + 1].v = wave.dot[i].v;
			//Wɑ΂Ĉړ
		wave.dot[i].y -= wave.dot[i].v;
	}
	
		//ZL[ŉx
	if (KeyBoard_Get(KEY_INPUT_Z) > 1) wave.dot[0].v = 2;

}

void Wave_Draw()
{
		//`
	for (int i = 0; i < 640; i++)
	{
		DrawPixel(wave.dot[i].x, wave.dot[i].y, GetColor(255, 255, 255));
	}
}

